#include <stdio.h>
#include <stdlib.h>
#include "event.h"
#include "event_queue.h"

EventQueue *new_event_queue()
{
  EventQueue *eq = (EventQueue *)malloc(sizeof(EventQueue));

  eq->next_id = 0;

  eq->first = NULL;
  eq->last = NULL;
  eq->size = 0;

  eq->finished_first = NULL;
  eq->finished_last = NULL;
  eq->finished_size = 0;

  return eq;
}


int insert_event(EventQueue *eq, int prio, int32_t (*func)(void*), void *param)
{
  eq->next_id++;

  Event *e = new_event(eq->next_id, 0, func, param);

  if ( eq->last == NULL ) {  //no entry
    eq->last = e;
  } else {
    set_pointer(eq->first, eq->first->next, e);
    set_pointer(e, eq->first, NULL);
  }

  eq->first = e;
  eq->size++;

  return eq->next_id;
}


int handle_next_event(EventQueue *eq)
{
  if ( eq->last == NULL ) return -1;

  Event *e = eq->last;

  eq->last = e->prev;

  if ( e->prev == NULL ) {
    eq->first = NULL;
  }

  if ( eq->last != NULL ) eq->last->next = NULL;

  set_pointer(e, NULL, NULL);

  //insert to finished
  if ( eq->finished_last == NULL ) {  //no entry
    eq->finished_last = e;
  } else {
    set_pointer(eq->finished_first, eq->finished_first->next, e);
    set_pointer(e, eq->finished_first, NULL);
  }

  eq->finished_first = e;

  eq->size--;
  eq->finished_size++;

  e->event_func(e->event_param);

  return 0;
}
