#include <stdio.h>
#include <sys/select.h>

int main(void)
{
  fd_set readfds;
  struct timeval tv;
  char buf1[4096], buf2[4096];

  char c;

  FILE *f = fopen("/etc/passwd", "r");

  int file_fd = fileno(f);
  int file_fd_in = fileno(stdin);

  printf("%d %d\n",file_fd, file_fd_in);

  while (1) {

    // since we got s2 second, it's the "greater", so we use that for
    // the n param in select()
    int n = 15; // 2 /*err*/ + 1

    // clear the set ahead of time
    FD_ZERO(&readfds);

    // add our descriptors to the set
    FD_SET(file_fd, &readfds);
    FD_SET(file_fd_in, &readfds);


    // wait until either socket has data ready to be recv()d (timeout 10.5 secs)
    tv.tv_sec = 1;
    tv.tv_usec = 500000;


    // args: #fds, read fds, write fds, error fds, timeval
    int rv = select(n, &readfds, NULL, NULL, &tv);

    if (rv == -1) {
      perror("select"); // error occurred in select()
    } else if (rv == 0) {
      printf("Timeout occurred!  No data after 1.5 seconds.\n");
      fclose(f);
      return 0;
    } else {
      // one or both of the descriptors have data
      int c = 0;
      if (FD_ISSET(file_fd, &readfds)) {
          printf("1\n");
          if ( recv(file_fd, buf1, sizeof buf1, 0) > 0 ) {
            printf("1: %s\n", buf1);
          }
          FD_CLR(file_fd, &readfds);
          c++;
      }
      if ((rv > c ) && (FD_ISSET(file_fd_in, &readfds))) {
          printf("2\n");
          if ( recv(file_fd_in, buf2, sizeof buf2, 0) > 0 ) {
            printf("2: %s\n", buf2);
          }
          FD_CLR(file_fd_in, &readfds);
      }
    }
  }

  fclose(f);
  return 0;

}